Qwt User's Guide: QwtScaleMap Class Reference

Qwt User's Guide 6.3.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
QwtScaleMap Class Reference

A scale map. More...

`#include <qwt_scale_map.h>`

## Public Member Functions
| QwtScaleMap ()
| Constructor.
| QwtScaleMap (const QwtScaleMap &)
| Copy constructor.
| ~QwtScaleMap ()
QwtScaleMap & | operator= (const QwtScaleMap &)
| Assignment operator.
void | setTransformation (QwtTransform *)
const QwtTransform * | transformation () const
| Get the transformation.
void | setPaintInterval (double p1, double p2)
| Specify the borders of the paint device interval.
void | setScaleInterval (double s1, double s2)
| Specify the borders of the scale interval.
double | transform (double s) const
double | invTransform (double p) const
double | p1 () const
double | p2 () const
double | s1 () const
double | s2 () const
double | pDist () const
double | sDist () const
bool | isInverting () const

## Static Public Member Functions
static QRectF | transform (const QwtScaleMap &, const QwtScaleMap &, const QRectF &)
static QRectF | invTransform (const QwtScaleMap &, const QwtScaleMap &, const QRectF &)
static QPointF | transform (const QwtScaleMap &, const QwtScaleMap &, const QPointF &)
static QPointF | invTransform (const QwtScaleMap &, const QwtScaleMap &, const QPointF &)

## Detailed Description

A scale map.

QwtScaleMap offers transformations from the coordinate system of a scale into the linear coordinate system of a paint device and vice versa.

Definition at line 26 of file qwt_scale_map.h.

## Constructor & Destructor Documentation

## ◆ QwtScaleMap() [1/2]

QwtScaleMap::QwtScaleMap | ( |  | ) |

Constructor.

The scale and paint device intervals are both set to [0,1].

Definition at line 21 of file qwt_scale_map.cpp.

## ◆ QwtScaleMap() [2/2]

QwtScaleMap::QwtScaleMap | ( | const QwtScaleMap & | other | ) |

Copy constructor.

Definition at line 33 of file qwt_scale_map.cpp.

## ◆ ~QwtScaleMap()

QwtScaleMap::~QwtScaleMap | ( |  | ) |

Destructor

Definition at line 49 of file qwt_scale_map.cpp.

## Member Function Documentation

## ◆ invTransform() [1/3]

QPointF QwtScaleMap::invTransform | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QPointF & | pos )
| static

Transform a rectangle from paint to scale coordinates

Parameters

  xMap | X map
  yMap | Y map
  pos | Position in paint coordinates

Returns
  Position in scale coordinates

See also
  transform()

Definition at line 187 of file qwt_scale_map.cpp.

## ◆ invTransform() [2/3]

QRectF QwtScaleMap::invTransform | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRectF & | rect )
| static

Transform a rectangle from paint to scale coordinates

Parameters

  xMap | X map
  yMap | Y map
  rect | Rectangle in paint coordinates

Returns
  Rectangle in scale coordinates

See also
  transform()

Definition at line 224 of file qwt_scale_map.cpp.

## ◆ invTransform() [3/3]

double QwtScaleMap::invTransform | ( | double | p | ) | const
| inline

Transform an paint device value into a value in the interval of the scale.

Parameters

  p | Value relative to the coordinates of the paint device

Returns
  Transformed value

See also
  transform()

Definition at line 154 of file qwt_scale_map.h.

## ◆ isInverting()

bool QwtScaleMap::isInverting | ( |  | ) | const
| inline

Returns
  True, when ( p1() < p2() ) != ( s1() < s2() )

Definition at line 164 of file qwt_scale_map.h.

## ◆ operator=()

QwtScaleMap & QwtScaleMap::operator= | ( | const QwtScaleMap & | other | ) |

Assignment operator.

Definition at line 55 of file qwt_scale_map.cpp.

## ◆ p1()

double QwtScaleMap::p1 | ( |  | ) | const
| inline

Returns
  First border of the paint interval

Definition at line 99 of file qwt_scale_map.h.

## ◆ p2()

double QwtScaleMap::p2 | ( |  | ) | const
| inline

Returns
  Second border of the paint interval

Definition at line 107 of file qwt_scale_map.h.

## ◆ pDist()

double QwtScaleMap::pDist | ( |  | ) | const
| inline

Returns
  qwtAbs(p2() - p1())

Definition at line 115 of file qwt_scale_map.h.

## ◆ s1()

double QwtScaleMap::s1 | ( |  | ) | const
| inline

Returns
  First border of the scale interval

Definition at line 83 of file qwt_scale_map.h.

## ◆ s2()

double QwtScaleMap::s2 | ( |  | ) | const
| inline

Returns
  Second border of the scale interval

Definition at line 91 of file qwt_scale_map.h.

## ◆ sDist()

double QwtScaleMap::sDist | ( |  | ) | const
| inline

Returns
  qwtAbs(s2() - s1())

Definition at line 123 of file qwt_scale_map.h.

## ◆ setPaintInterval()

void QwtScaleMap::setPaintInterval | ( | double | p1,
|  | double | p2 )

Specify the borders of the paint device interval.

Parameters

  p1 | first border
  p2 | second border

Definition at line 119 of file qwt_scale_map.cpp.

## ◆ setScaleInterval()

void QwtScaleMap::setScaleInterval | ( | double | s1,
|  | double | s2 )

Specify the borders of the scale interval.

Parameters

  s1 | first border
  s2 | second border

Warning
  scales might be aligned to transformation depending boundaries

Definition at line 100 of file qwt_scale_map.cpp.

## ◆ setTransformation()

void QwtScaleMap::setTransformation | ( | QwtTransform * | transform | ) |

Initialize the map with a transformation

Definition at line 76 of file qwt_scale_map.cpp.

## ◆ transform() [1/3]

QPointF QwtScaleMap::transform | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QPointF & | pos )
| static

Transform a point from scale to paint coordinates

Parameters

  xMap | X map
  yMap | Y map
  pos | Position in scale coordinates

Returns
  Position in paint coordinates

See also
  invTransform()

Definition at line 206 of file qwt_scale_map.cpp.

## ◆ transform() [2/3]

QRectF QwtScaleMap::transform | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRectF & | rect )
| static

Transform a rectangle from scale to paint coordinates

Parameters

  xMap | X map
  yMap | Y map
  rect | Rectangle in scale coordinates

Returns
  Rectangle in paint coordinates

See also
  invTransform()

Definition at line 153 of file qwt_scale_map.cpp.

## ◆ transform() [3/3]

double QwtScaleMap::transform | ( | double | s | ) | const
| inline

Transform a point related to the scale interval into an point related to the interval of the paint device

Parameters

  s | Value relative to the coordinates of the scale

Returns
  Transformed value

See also
  invTransform()

Definition at line 137 of file qwt_scale_map.h.

## ◆ transformation()

const QwtTransform * QwtScaleMap::transformation | ( |  | ) | const

Get the transformation.

Definition at line 88 of file qwt_scale_map.cpp.